﻿<?php
///////////////////////////////////////////////////////////////////////////
require_once 'utils.php';

class Cursor
{

	    private $m_feed;
	    private $m_feed_url;
	    private $m_items_count;
        private $m_last_ref;

    ///////////////////////////////////////////////////////////////////////

    public function __construct($media_url)
    {
        if ($media_url === 'main_menu:fav')
            $this->m_feed_url = 'main_menu:fav';
        else
            HD::decode_user_data($media_url, $media_str, $this->m_feed_url);

        $this->m_items_count = 0;
        $this->m_feed = 0;
        $this->m_last_ref = "";
    }

    private function parse_page($url)
    {
        $api = HOST_API_URL;
        
        $items = array();
		$url = $url;
        $doc = HD::http_get_document($url);
		
		////////hd_print("--->>> doc: $doc");
        $videos = explode('<h4 class="viewn_title">', $doc);
        unset($videos[0]);
        $videos = array_values($videos);

        foreach($videos as $video)
        {	
            $tmp = explode('<a href="', $video);
			$season_refs = str_remove_spec(strstr($tmp[1], '"', true));
            
            $tmp = explode('<img src="', $video);
            $season_image = str_remove_spec(strstr($tmp[1], '"', true));
            if ($season_image == false)
			{
			$season_image = 'plugin_file://skins/no_cover.png';
			}
			
			$tmp = explode('</h4>', $video);
            $season_descr = str_remove_spec(strstr($tmp[1], '<div class="viewn_open">', true));
            $season_descr = str_replace("</div>", " * ", $season_descr);
			$season_descr = strip_tags($season_descr);
			
			
			$tmp = explode('">', $video);
            if (count($tmp) < 2)
                continue;
            $season_title = str_remove_spec(strstr($tmp[1], '<', true));
			
			$season_ref = $season_refs . '&&' . $season_image . '&&'. $season_descr;
            
			// //hd_print("--->>> season_ref: $season_ref");
            // //hd_print("--->>> season_title: $season_title");
            // //hd_print("--->>> season_image: $season_image"); 
            
            array_push
            (
                $items,
                HD::encode_user_data
                (
                    array
                    (
                        'video_id' => $season_ref,
                        'season_title' => $season_title,
                        'season_ref' => $season_ref,
                        'season_image' => $season_image,
                        'is_has_new' => false
                    )
                )
            );
            ++$this->m_items_count;
        }
        
        return $items;
    }
////////////////////////////////////////////////////////////////
	private function parse_page_search($url)
    {
        $api = HOST_API_URL;
        
        $items = array();

		$doc = HD::http_get_document($url);
		
		$videos = explode('<div class="eTitle"', $doc);
        unset($videos[0]);
        $videos = array_values($videos);

        foreach($videos as $video)
        {	
            // //hd_print("--->>> video: $video");
			$tmp = explode('<a href="', $video);
			$season_ref = str_remove_spec(strstr($tmp[1], '"', true));
                  
			$season_image = 'plugin_file://skins/logo.png';

			
			$tmp = explode('normal">', $video);
            if (count($tmp) < 2)
                continue;
            $season_title = str_remove_spec(strstr($tmp[1], '</div>', true));
			$season_title = strip_tags($season_title);
            
			$season_ref = $season_ref . '&&' . $season_image . '&& Результаты поиска';
            // //hd_print("--->>> season_ref: $season_ref");
            // //hd_print("--->>> season_title: $season_title");
            // //hd_print("--->>> season_image: $season_image");
            
            array_push
            (
                $items,
                HD::encode_user_data
                (
                    array
                    (
                        'video_id' => $season_ref,
                        'season_title' => $season_title,
                        'season_ref' => $season_ref,
                        'season_image' => $season_image,
                        'is_has_new' => false
                    )
                )
            );
            ++$this->m_items_count;
        }
        
        return $items;
    }
	///////////////////////////////////////////////////////////////////
    private function parse_subcategory()
    {
        ////////hd_print("--> parse subcategory: started...");
        $subcategory = $this->m_feed_url;
        $ref = $subcategory->subcategory_ref;
        $api = HOST_API_URL;
        
        $url = $api . $ref;
			$tmp = explode('/1', $ref);
            if (count($tmp) > 0)
            $ref1 = $tmp[0];
            $ref2 = $tmp[1];
			//hd_print("--->>> 1: $ref1");
			//hd_print("--->>> 2: $ref2");
		
        if ($this->m_feed > 0)
			$url = $api . $ref1 . '/' . ($this->m_feed + 1). $ref2;
		//hd_print("--->>> url: $url");
        return $this->parse_page($url);
    }

    ///////////////////////////////////////////////////////////////////////
    private function parse_search_result($search)
    {
        ////////hd_print("--> parse search result: started... $search");
        $api = HOST_API_URL;
        $url = $api . "/search/?q=$search&m=video&t=0";
				
        if ($this->m_feed > 0)
			
            $url = $api . '/search/?q='.$search.';t=0;p='.($this->m_feed + 1).';md=video';
        
        
		//hd_print("url--->>>: $url");
        return $this->parse_page_search($url);
    }
    ///////////////////////////////////////////////////////////////////////

    private function get_next_fav(&$plugin_cookies)
    {
        ////////hd_print("--> get favorites: started... $this->m_feed");
        
        $fav_items = isset($plugin_cookies->fav_items) ? $plugin_cookies->fav_items : '';
        
        $ref = "";
        
        $n = 0;
        foreach (ListUtil::string_to_list($fav_items) as $item)
        {
            if ($item == "")
                continue;
            
            if ($n == $this->m_feed)
            {
                $ref = $item;
            }

            ++$n;
            
        }

        if ($ref == "")
            return false;
        
        $items = array();

        $c = VideoCache::get($ref);
        if (!is_null($c))
        {
            array_push
            (
                $items,
                $c
            );

            ++$this->m_items_count;

            return $items;
            
        }

        $api = HOST_API_URL;
        
        

        //$url = $api . $ref;
        
        $tmp = explode('&&', $ref);
        $refs = $tmp[0];
		$season_image = $tmp[1];
				
		$doc = HD::http_get_document($refs);
       	
		////////hd_print("doc: --->>>$doc");
		$tmp = strstr($doc, 'class="eBlock">');
        $info_block = strstr($tmp, '<div id="vk_like">', true);
		$info_block = str_replace("vkontakte.ru", "vk.com", $info_block);
        //////hd_print("info_block: --->>>$info_block");
        // title
        $tmp = explode('<div class="eTitle">', $info_block);
        $video_title = str_remove_spec(strstr($tmp[1], '</td></tr>', true));
        $season_title = strip_tags($video_title);

        $series_block = '';
        $tmp = strstr($doc, '<select size="1" name="fileId" onchange="this.form. submit();">');
        
        $is_has_new = false;

        if ($tmp && isset($plugin_cookies->$ref))
        {
            $series_block = strstr($tmp, '</select>', true);
            $videos = explode('value="', $series_block);
            unset($videos[0]);
            $videos = array_values($videos);

            foreach($videos as $video)
            {
                $fileid = strstr($video, '"', true);
                $episode_ref = $url . "?fileId=$fileid";
                
                ////////hd_print("--->>> episode_ref: $episode_ref");

                if (isset($plugin_cookies->$ref))
                    if (!ListUtil::is_in_list($plugin_cookies->$ref, $episode_ref))
                        $is_has_new = true;
                            
                if ($is_has_new)
                    break;
            }
        }
        
        array_push
        (
            $items,
            HD::encode_user_data
            (
                array
                (
                    'video_id' => $ref,
                    'season_title' => $season_title,
                    'season_ref' => $ref,
                    'season_image' => $season_image,
                    'is_has_new' => $is_has_new
                )
            )
        );

        ++$this->m_items_count;

        return $items;
    }
    ///////////////////////////////////////////////////////////////////////

    public function next_chunk($plugin_cookies)
    {
	    ////////hd_print("--> next_chunk(): started...");

	    $items = array();

        if ($this->m_feed_url === 'main_menu:fav')
        {
            ////////hd_print("--> parse favorites: started...");
            
            $items = $this->get_next_fav($plugin_cookies);
            ++$this->m_feed;

            if ($items === false)
                return false;
            
            return count($items) > 0 ? $items : false;
        }
	    if (HD::has_attribute($this->m_feed_url, 'ser_feed'))
	    {
		    ////////hd_print("--> search: started...");
            
		    $search_text = $this->m_feed_url->ser_feed;
            
            $items = $this->parse_search_result($search_text);
            ++$this->m_feed;
            
		    ////////hd_print("--> search for: " . $search_text);

            if ($items === false)
                return false;
                
            ////////hd_print("--> next_chunk(): found " . count($items) . " items.");
            return count($items) > 0 ? $items : false;
	    }
        else if (HD::has_attribute($this->m_feed_url, 'subcategory_ref'))
        {
           $items = $this->parse_subcategory();
            ++$this->m_feed;

            if ($items === false)
                return false;
                
            ////////hd_print("--> next_chunk(): found " . count($items) . " items.");
            return count($items) > 0 ? $items : false;
        }

        return false;
    }
}

///////////////////////////////////////////////////////////////////////////
?>
